function neighbors = CollaborativeFiltering( TrustValue, expertNum, type, param )
%COLLABORATIVEFILTERING Collaborative filtering
%Collaborative Filtering Based on Trust Relationship
%TrustValue: Trust value matrix
%expertNum Expert number
%type Type of collaborative filtering 1Threshold method  2N-neighbor method
%param If threshold -- similarity threshold; N nearest neighbors -- select number of neighbors
    [Y, I] = sort(TrustValue(expertNum,:) , 'descend');
    if type == 2 
        neighbors = I(1,1:param);
    else
        neighbors = [];
        for i = 1 : length(Y)
            if Y(i) >= param
                neighbors = [neighbors, I(i)];
            else
                break;
            end
        end
    end
end

