function [isValidNode,Reputation] = GlobalBelief(SN)
%GlobalBelief Obtaining a global trust score according to the initial trust matrix
%According to the in-degree, calculate the global trust score, and directly count whether the node can be a relay node
    N = length(SN);
    Reputation = zeros(1,N); 
    isValidNode = [];
    GoodBelief = [];
    BadBelief = [];
    SumBelief = [];
    for i = 1:N
        good = 0; bad = 0;
        for j = 1:N
            if SN(j,i) ~= inf && SN(j,i) > 0 
                good = good + 1;
            elseif SN(j,i) < 0
                bad = bad + 1;
            end
        end
        GoodBelief = [GoodBelief good];
        BadBelief = [BadBelief bad];
        SumBelief = [SumBelief,good + bad];
        if bad / (good + bad) <= 0.33   %Judging whether the node can serve as a relay node or not
            isValidNode = [isValidNode,true];
        else
            isValidNode = [isValidNode,false];
        end
    end
    %Calculate the global confidence score of each expert
    for i = 1:length(SN)
        Reputation(i) = ((GoodBelief(i) - min(GoodBelief)) - (BadBelief(i) - min(BadBelief))) / (max(SumBelief) - min(SumBelief));
    end
end

