function [ avgConsistency ] = KAvgConsistency( cluster, centroids, HFSs, weight)
%KAVGCONSISTENCY Consistency after computing Zhang clustering
    [row,~] = size(cluster);
    Ds = [];
    for i = 1 : row
        sumD = 0;
        for j = 2 : cluster(i,1)
            sumD = sumD + AttributeDistance(centroids{i}, HFSs{cluster(i,j)}, weight);
        end
        D = sumD / (cluster(i,1) - 1);
        Ds = [Ds, D];
    end
    avgConsistency = mean(Ds(:));
end

