function creditScore = getCreditScore(Graph , expertNum)
%GETCREDITSCORE Obtain the trust score of an expert in the dissemination process
%After the trust in-value of each user is summed up, it is uniformly allocated to the trust out-degree associated users as its own trust resource.
    creditScore = 0;
   % preNodes = find(0<Graph(:,expertNum) & Graph(:,expertNum)<inf); %Get all the nodes that trust the node according to the Graph
    preNodes = find(Graph(:,expertNum)<inf); %Get all the predecessor nodes of the node (including trust and distrust) according to the Graph.
    nextNodes = find(0<Graph(expertNum,:) & Graph(expertNum,:)<inf); %Obtaining a trust node of the node according to a Graph
    for i = 1 : length(preNodes)
        creditScore = creditScore + Graph(preNodes(i),expertNum);
    end
    creditScore = creditScore / length(nextNodes);
end

