global SN  %Social network matrix, i.e., the initial trust matrix, with rows indicating who is trusted and columns indicating who is trusted
global type %Type of collaborative filtering 1Threshold method  2N-nearest neighbor method
global param %Collaborative filtering parameters  If type = 1 it's the threshold    If type = 2 it's the number of neighbors N
%type = 2;
%param = 10;

%The aggregation operator considers all people for whom a trust relationship exists
type = 1;
param = 0;

SN = [0,inf,inf,inf,inf,0.6,0.6,1,1,inf,inf,inf,inf,inf,-0.6,inf,inf,inf,-0.8,inf;
      inf,0,inf,inf,0.6,inf,inf,inf,inf,inf,inf,0.6,0.6,inf,inf,inf,inf,inf,inf,inf;
      inf,inf,0,inf,inf,0.8,inf,inf,inf,0.6,0.6,inf,inf,1,inf,inf,inf,inf,inf,inf;
      inf,inf,inf,0,inf,inf,0.8,0.8,inf,inf,inf,inf,0.8,inf,inf,1,0.6,0.6,inf,inf;
      0.4,inf,0.8,inf,0,inf,inf,0.6,inf,0.6,inf,inf,inf,inf,inf,inf,inf,inf,1,inf;
      inf,inf,inf,inf,0.6,0,inf,inf,0.8,inf,inf,inf,inf,inf,0.8,inf,inf,0.8,inf,inf;
      inf,inf,inf,0.6,inf,inf,0,0.6,inf,inf,inf,inf,inf,inf,inf,inf,inf,inf,inf,inf;
      -0.6,inf,inf,0.8,inf,inf,inf,0,inf,inf,inf,inf,inf,-0.2,inf,inf,inf,inf,inf,0.8;
      inf,inf,inf,inf,inf,inf,inf,inf,0,0.8,0.8,inf,inf,inf,inf,inf,inf,inf,inf,inf;
      inf,inf,inf,0.8,inf,inf,inf,inf,inf,0,0.8,inf,inf,inf,inf,inf,inf,inf,inf,inf;
      inf,inf,1,inf,inf,inf,1,inf,inf,inf,0,inf,inf,inf,inf,inf,inf,inf,inf,inf;
      inf,0.6,inf,inf,inf,inf,inf,inf,inf,inf,inf,0,inf,0.4,0.8,inf,inf,inf,1,1;
      inf,0.8,inf,1,inf,inf,inf,inf,inf,inf,inf,inf,0,inf,inf,0.4,0.8,inf,inf,inf;
      inf,0.6,inf,1,inf,0.6,inf,inf,inf,inf,0.4,0.4,inf,0,inf,inf,inf,inf,inf,inf;
      inf,inf,inf,-1,inf,inf,inf,inf,inf,-0.8,inf,inf,inf,inf,0,inf,inf,inf,-0.2,inf;
      1,inf,inf,inf,inf,inf,inf,0.8,inf,inf,inf,inf,inf,inf,0.6,0,inf,inf,inf,inf;
      inf,inf,inf,inf,inf,inf,inf,1,inf,inf,inf,inf,0,inf,inf,inf,0,inf,inf,inf;
      inf,inf,0.6,inf,inf,inf,inf,1,inf,0.6,inf,inf,inf,inf,inf,inf,inf,0,inf,inf;
      inf,inf,0.8,inf,inf,inf,inf,inf,inf,inf,inf,inf,inf,inf,inf,inf,inf,inf,0,inf;
      inf,inf,0.6,inf,inf,inf,inf,inf,inf,inf,inf,0.8,inf,inf,inf,inf,inf,inf,0.6,0;
      ];
%The trust relationship can be obtained by reading the file, with the rows indicating who to trust and the columns indicating who to trust me
% num = xlsread('SN.xlsx');
% num(find(isnan(num)==1)) = inf;

%Original evaluation matrix
HFSs = {
    {
    [0.6,0.72,0.78,0.85,0.9];[];[0.2,0.32,0.38,0.45];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[];
    [0.6,0.72,0.78,0.85,0.9];[];[0.4,0.52,0.58,0.65];[0.75,0.82,0.88,0.95];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9]
    };
    {
    [0.6,0.72,0.78,0.85,0.9];[];[];[0.4,0.52,0.58,0.65];[0.2,0.32,0.38,0.45];[0.4,0.52,0.58,0.65];
    [0.6,0.72,0.78,0.85,0.9]; [0.2,0.32,0.38,0.45];[];[0.75,0.82,0.88,0.95];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65]
    };
    {
    [0.6,0.72,0.78,0.85,0.9];[];[0.2,0.32,0.38,0.45];[0.6,0.72,0.78,0.85,0.9];[];[0.4,0.52,0.58,0.65];
    [0.4,0.52,0.58,0.65];[0.75,0.82,0.88,0.95];[0.6,0.72,0.78,0.85,0.9];[0.75,0.82,0.88,0.95];[0.2,0.32,0.38,0.45];[0.4,0.52,0.58,0.65]
    };
    {
    [0.2,0.32,0.38,0.45];[];[0.75,0.82,0.88,0.95];[];[0.4,0.52,0.58,0.65];[];
    [0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65];[0.75,0.82,0.88,0.95];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65]
    };
    {
    [0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];
    [0.6,0.72,0.78,0.85,0.9];[0.75,0.82,0.88,0.95];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45]
    };
    {
    [0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45];[0.6,0.72,0.78,0.85,0.9];[];[];
    [0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45];[0.4,0.52,0.58,0.65];[0.75,0.82,0.88,0.95];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9]
    };
    {
    [0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45];[];[0.4,0.52,0.58,0.65];[];[0.4,0.52,0.58,0.65];
    [0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45];[0.6,0.72,0.78,0.85,0.9];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65]
    };
    {
    [0.6,0.72,0.78,0.85,0.9];[];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];
    [0.4,0.52,0.58,0.65];[0.05,0.12,0.18,0.25];[0.6,0.72,0.78,0.85,0.9];[];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65]
    };
    {
    [0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];[];[0.6,0.72,0.78,0.85,0.9];
    [0.4,0.52,0.58,0.65];[];[0.75,0.82,0.88,0.95];[0.75,0.82,0.88,0.95];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65]
    };
    {
    [0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.05,0.12,0.18,0.25];[0.4,0.52,0.58,0.65];
    [0.75,0.82,0.88,0.95];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45]
    };
    {
    [0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45];[0.6,0.72,0.78,0.85,0.9];[0.6,0.72,0.78,0.85,0.9];[0.75,0.82,0.88,0.95];
    [0.6,0.72,0.78,0.85,0.9];[0.95,1,1,1];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.6,0.72,0.78,0.85,0.9]
    };
    {
    [0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65];[0.75,0.82,0.88,0.95];[0.4,0.52,0.58,0.65];
    [0.6,0.72,0.78,0.85,0.9];[0.75,0.82,0.88,0.95];[0.75,0.82,0.88,0.95];[0.75,0.82,0.88,0.95];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65]
    };
    {
    [0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];[0.2,0.32,0.38,0.45];[0.6,0.72,0.78,0.85,0.9];[];[];
    [0.4,0.52,0.58,0.65];[];[0.6,0.72,0.78,0.85,0.9];[0.75,0.82,0.88,0.95];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65]
    };
    {
    [0.2,0.32,0.38,0.45];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.6,0.72,0.78,0.85,0.9];[0.75,0.82,0.88,0.95];
    [0.2,0.32,0.38,0.45];[0.6,0.72,0.78,0.85,0.9];[0.75,0.82,0.88,0.95];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65]
    };
    {
    [0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];
    [0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45];[0.75,0.82,0.88,0.95];[0.75,0.82,0.88,0.95];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65]
    };
    {
    [0.6,0.72,0.78,0.85,0.9];[0.6,0.72,0.78,0.85,0.9]; [0.2,0.32,0.38,0.45];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65];
    [0.4,0.52,0.58,0.65];[0.75,0.82,0.88,0.95];[0.6,0.72,0.78,0.85,0.9];[0.75,0.82,0.88,0.95];[0.2,0.32,0.38,0.45];[0.4,0.52,0.58,0.65]
    };
    {
    [0.2,0.32,0.38,0.45];[0.6,0.72,0.78,0.85,0.9];[0.75,0.82,0.88,0.95];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];
    [0.2,0.32,0.38,0.45];[0.4,0.52,0.58,0.65];[0.75,0.82,0.88,0.95];[0.75,0.82,0.88,0.95];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65]
    };
    {
    [0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.6,0.72,0.78,0.85,0.9];[0.05,0.12,0.18,0.25];[0.4,0.52,0.58,0.65];
    [0.75,0.82,0.88,0.95];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];[0.75,0.82,0.88,0.95];[0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45]
    };
    {
    [0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];
    [0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45];[0.75,0.82,0.88,0.95];[0.75,0.82,0.88,0.95];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65]
    };
    {
    [0.6,0.72,0.78,0.85,0.9];[0.6,0.72,0.78,0.85,0.9];[0.2,0.32,0.38,0.45];[0.6,0.72,0.78,0.85,0.9];[0.4,0.52,0.58,0.65];[0.4,0.52,0.58,0.65];
    [0.4,0.52,0.58,0.65];[0.75,0.82,0.88,0.95];[0.6,0.72,0.78,0.85,0.9];[0.75,0.82,0.88,0.95];[0.2,0.32,0.38,0.45];[0.4,0.52,0.58,0.65]
    }
};

globalReputationWeight = 0.5; %Prestige Proportion

[r,c] = size(SN);  %Obtain the size of the trust matrix and the number of expertsr == c,In order to write code to distinguish the meaning, you can also use N = length (SN) to get the quantity directly.
[isValidNode,Reputation] = GlobalBelief(SN);  %Gets whether the node can be a relay node and the global reputation

TrustValue = zeros(r,c); %Trust value matrix
for i = 1:r
    for j = 1:c
        if i == j
            continue
        end
        if IsDirTrust(i,j)
            TrustValue(i,j) = Reputation(j) * globalReputationWeight + (1 - globalReputationWeight) * SN(i,j);
        else
            TrustValue(i,j) = trustAggregation(SN, i, j, isValidNode, Reputation(j) ,globalReputationWeight);
        end
    end
end

nHFSs = {};
for i = 1 : length(HFSs)
   HFS = HFSs{i};
   atrribute = IsIncomplete(HFS);
   if ~isempty(atrribute)
       HFS = FillLostValue(HFSs, i, atrribute, TrustValue);
   end
   nHFSs{end + 1,1} = HFS;
end



%Variables that can be set according to your own needs. For the convenience of testing, I extract them.
nearN = 3;  %This is our own clustering method, with a few nearest neighbors as a reference.
centerNum = 4; %The number of clusters, our own method is actually best chosen based on density
loopTimes = 10; %Maximum iterations of Zhang clustering method
 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%-------Group Consensus degree---------------%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%Drawing a unified index map after clustering
% %%%%%%%%%%%%%%Data needed for drawing%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %Your own way
OavgConsistency = [];  %Consistency of each clustering
for i = 1 : 20
    [cluster,Dham] = Clusting(nHFSs, nearN, centerNum);
    OavgConsistency = [OavgConsistency, AvgConsistency(cluster, Dham)];
end
% % 
% % %Zhang
KavgConsistency = [];  %Consistency of each clustering
FavgConsistency = [];
for i = 1 : 20
    [centroids, cluster, weight] = Zhang(nHFSs, centerNum, loopTimes);  %The second parameter is the number of clusters, and the third parameter is the maximum number of iterations
    KavgConsistency = [KavgConsistency, KAvgConsistency( cluster, centroids, nHFSs, weight)];
%     [centroidsF, clusterF] = FCM(nHFSs, centerNum, loopTimes);
%     FavgConsistency = [FavgConsistency, KAvgConsistency( clusterF, centroidsF, nHFSs, weight)];
end

% % 
% %%%Draw a picture%%%
% plot(FavgConsistency,'-+g')
% hold on
plot(KavgConsistency,'-Ob')
title('Group Consensus degree the Number of clusters=5')
hold on
plot(OavgConsistency,'-*r')
legend('Zhang ','Our Method');
ylabel('Group Consensus degree indicator');
xlabel('Number of experiments');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%---------Effectiveness index----------%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Draw your own before and after clustering comparison results

% % %%%%%%%%%%%%Required experimental data%%%%%%%%%%%%%
%   [cluster,Dham] =  Clusting(nHFSs, nearN, centerNum);

%%%%%%%%%%%%%%Calculate the data of the graph from the raw data%%%%%%%%%%%%%%%%%%%
% [row,col] = size(cluster); %Obtain how many clusters there are
% Ds = [];
% Dpro = 0;
% %Calculate the original average consistency index before clustering
% for i = 1 : col
%     Dpro = Dpro + Dham(3,i);
% end
% Dpro = Dpro / 20;

%Calculate the average consensus index of the K-th group
% for i = 1 : row
%     sumD = 0;
%     for j = 3 : cluster(i,1)
%         center = cluster(i,2); %Cluster center
%         sumD = sumD + Dham(center, cluster(i,j));
%     end
%     D = sumD / (cluster(i,1) - 1);
%     Ds = [Ds, D];
% end

%%%%%%%%%%%%%%%%%%%%Start drawing%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot([1,4],[Dpro,Dpro],'--b','linewidth',2);
% title('OWA complementary approach')
% hold on
% plot([1,4],[mean(Ds(:)),mean(Ds(:))],'r','linewidth',2); %Note: The consistency after the third clustering is actually the average value of the second step, which is directly plotted, and mean is the average value.
% hold on
% legend('Before clustering','After clustering');
% bar(Ds,0.4);
% set(gca, 'XTickLabel',{'','G1','','G2','','G3','','G4'}); 
% ylabel('Average consensus degree indicator');
% xlabel('clusters');
% ylim([0 0.22])
% for i = 1:length(Ds)
%     text(i,Ds(i)+0.01,num2str(Ds(i),3),'VerticalAlignment','middle','HorizontalAlignment','center');
% end
% box off
% %End of drawing your own effectiveness graph







        
        