function comTrustValue = trustAggregation(SN,src,des,isValidNode,reputation, w)
%trustAggregation Trust value aggregation
%SN Trust Matrix
%src Source node
%des Destination node
%isValidNode Can it be used as a relay node matrix
%reputation Global trust can also be understood as prestige.
%w Global Reputation Weight
    
    %Get all paths to indirect trust
    routes = findPath(SN,src,des,1,isValidNode);
    [rows, cols] = size(routes); %rows Number of paths cols Number of paths
    %Calculate the indirect trust
    switch rows
        case 1
            innrTrustValue = routes(cols);
        case 0 
            innrTrustValue = 0;
        otherwise
            innrTrustValue = sum(routes(:,cols)) / rows;  %Trust aggregation of different paths
    end
    
    %Comprehensive trust value = w* global reputation + 1-w * indirect trust value
    comTrustValue = w * reputation + innrTrustValue * (1 - w);
end

